const AppSystem = imports.gi.Shell.AppSystem.get_default();
const GMenu     = imports.gi.GMenu;
const Me        = imports.misc.extensionUtils.getCurrentExtension();

const Prefs = Me.imports.prefs;

let hack  = {};
let undos = [];

function init() {
    function walk(dir) {
        if (!dir.get_is_nodisplay()) {
            for (let dirs = [ dir ], apps = [], iter = dir.iter();;) {
                switch (iter.next()) {
                case GMenu.TreeItemType.DIRECTORY:
                    let result = walk(iter.get_directory());
                    dirs = dirs.concat(result.dirs);
                    apps = apps.concat(result.apps.filter(function(app, i, a) {
                        return apps.indexOf(app) < 0;
                    }));
                    break;
                case GMenu.TreeItemType.ENTRY:
                    let app = AppSystem.lookup_app_by_tree_entry(iter.get_entry());
                    if (!app.get_app_info().get_nodisplay()) {
                        apps.push(app);
                    }
                    break;
                case GMenu.TreeItemType.INVALID:
                    return { dirs: dirs, apps: apps };
                }
            }
        }
        return { dirs : [], apps: [] };
    }

    hack = {
        install : function() {
            let result = walk(AppSystem.get_tree().get_root_directory());
            result.apps.sort(function(a, b) {
                return a.get_name().localeCompare(b.get_name());
            });

            Prefs.setHacks(
                result.apps.map(function(app, i, a) {
                    return app.get_app_info().get_filename().replace(/.*\//g, '');
                }),
                result.apps.map(function(app, i, a) {
                    return app.get_name();
                }),
                result.dirs.map(function(dir, i, a) {
                    return dir.get_menu_id();
                }),
                result.dirs.map(function(dir, i, a) {
                    return dir.get_name();
                })
            );
        }
    };
}

function enable() {
    function reset() {
        disable();
        enable();
    }

    hack.install();

    undos.push(
        Prefs.connect(AppSystem, 'installed-changed', hack.install),
        Prefs.onHacksHack(reset)
    );
}

function disable() {
    while(undos.length > 0) {
        undos.pop()();
    }
}
