const Lang          = imports.lang;
const Me            = imports.misc.extensionUtils.getCurrentExtension();
const OverviewGroup = imports.ui.main.overview._group;
const SearchResults = imports.ui.main.overview._viewSelector._searchResults._content;

const Prefs = Me.imports.prefs;

let undos = [];

function enable() {
    function reset() {
        disable();
        enable();
    }

    if (Prefs.getCompactSearchResults()) {
        SearchResults.add_style_class_name('no-spacing');
        undos.push(
            Lang.bind(SearchResults, SearchResults.remove_style_class_name, 'no-spacing')
        );
    }

    if (Prefs.getOpaqueOverview()) {
        OverviewGroup.add_style_class_name('opaque');
        undos.push(
            Lang.bind(OverviewGroup, OverviewGroup.remove_style_class_name, 'opaque')
        );
    }

    undos.push(
        Prefs.onSearchResultsStyleChange(reset),
        Prefs.onOverviewStyleChange(reset)
    );
}

function disable() {
    while(undos.length > 0) {
        undos.pop()();
    }
}
